/*
 * Copyright 2010 Alibaba Group Holding Limited.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.alibaba.antx.config;

import com.alibaba.toolkit.util.exception.ChainedRuntimeException;

/**
 * һauto config쳣
 * 
 * @author Michael Zhou
 */
public class ConfigException extends ChainedRuntimeException {
    private static final long serialVersionUID = -756372236339875155L;

    /**
     * һ쳣
     */
    public ConfigException() {
        super();
    }

    /**
     * һ쳣
     * 
     * @param message 쳣Ϣ
     */
    public ConfigException(String message) {
        super(message);
    }

    /**
     * һ쳣
     * 
     * @param message 쳣Ϣ
     * @param cause 쳣ԭ
     */
    public ConfigException(String message, Throwable cause) {
        super(message, cause);
    }

    /**
     * һ쳣
     * 
     * @param cause 쳣ԭ
     */
    public ConfigException(Throwable cause) {
        super(cause);
    }
}
