/*
 * Copyright 2010 Alibaba Group Holding Limited.
 * All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.alibaba.toolkit.util.regex;

import org.apache.oro.text.regex.MalformedPatternException;
import org.apache.oro.text.regex.Pattern;
import org.apache.oro.text.regex.PatternCompiler;
import org.apache.oro.text.regex.PatternMatcher;

/**
 * ʾһƥpattern.
 *
 * @version $Id: MatchPattern.java,v 1.1 2003/07/03 07:26:34 baobao Exp $
 * @author Michael Zhou
 */
public class MatchPattern {
    private Pattern pattern;

    /**
     * µpattern.
     */
    public MatchPattern() {
    }

    /**
     * µpattern.
     *
     * @param pattern ƥʽpattern
     */
    public MatchPattern(Pattern pattern) {
        this.pattern = pattern;
    }

    /**
     * µpattern.
     *
     * @param compiler pattern
     * @param pattern  ƥʽpattern
     *
     * @throws MalformedPatternException patternϷ
     */
    public MatchPattern(PatternCompiler compiler, String pattern)
            throws MalformedPatternException {
        this.pattern = compiler.compile(pattern);
    }

    /**
     * µpattern.
     *
     * @param compiler pattern
     * @param pattern  ƥʽpattern
     * @param options  ѡ
     *
     * @throws MalformedPatternException patternϷ
     */
    public MatchPattern(PatternCompiler compiler, String pattern, int options)
            throws MalformedPatternException {
        this.pattern = compiler.compile(pattern, options);
    }

    /**
     * pattern.
     *
     * @param pattern ƥʽpattern
     */
    public void setPattern(Pattern pattern) {
        this.pattern = pattern;
    }

    /**
     * ȡƥʽpattern.
     *
     * @return ƥʽpattern
     */
    public Pattern getPattern() {
        return pattern;
    }

    /**
     * ƥpattern, ɹ, 򷵻<code>true</code>.  ߿ͨ<code>context.getMatchItem()</code>ȡƥ.
     *
     * @param context  ƥ
     *
     * @return ƥɹ, 򷵻<code>true</code>
     */
    public boolean matches(MatchContext context) {
        PatternMatcher matcher = context.getMatcher();

        if (matcher.contains(context.getInputReset(), pattern)) {
            MatchItem item = context.createMatchItem(this, matcher.getMatch());

            context.setLastMatchItem(item);
            return true;
        }

        return false;
    }
}
